Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1512259 - clang: Missing definition of _CALL_ELF on ppc64le
Summary: clang: Missing definition of _CALL_ELF on ppc64le
Keywords:
Status: NEW
Alias: None
Product: Fedora EPEL
Classification: Fedora
Component: clang
Version: epel7
Hardware: ppc64le
OS: Linux
low
low
Target Milestone: ---
Assignee: Dave Airlie
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-11-12 07:41 UTC by Fabio Massimo Di Nitto
Modified: 2017-11-14 12:02 UTC (History)
9 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:


Attachments (Terms of Use)

Description Fabio Massimo Di Nitto 2017-11-12 07:41:48 UTC
Hey guys,

this appears to be a duplicate of https://bugzilla.redhat.com/show_bug.cgi?id=1058258

first of all, I fully understand that epel + clang are NOT a supported combination on RHEL, and it´s also entirely possible this bug is in clang. the error message points me at glibc at least, and I would appreciate any guidance on how to get it resolved.

When building anything, on RHEL7.5 on ppc64le using clang, we get that error message.

[root@tom ~]# cat main.c 
#include <stdio.h>

int main(void)
{
        printf("Hello world\n");
        exit(0);
}

[root@tom ~]# clang main.c 
In file included from main.c:1:
In file included from /usr/include/stdio.h:27:
In file included from /usr/include/features.h:399:
/usr/include/gnu/stubs.h:11:11: fatal error: 'gnu/stubs-64-v1.h' file not found
# include <gnu/stubs-64-v1.h>
          ^
1 error generated.

Version-Release number of selected component (if applicable):

[root@tom ~]# uname -a
Linux tom.lab.msp.redhat.com 3.10.0-693.2.2.el7.ppc64le #1 SMP Sat Sep 9 03:58:38 EDT 2017 ppc64le ppc64le ppc64le GNU/Linux

[root@tom ~]# rpm -q -a |grep -E "(clang|glibc*)"
glibc-2.17-196.el7.ppc64le
glibc-devel-2.17-196.el7.ppc64le
glibc-common-2.17-196.el7.ppc64le
glibc-headers-2.17-196.el7.ppc64le
clang-3.4.2-8.el7.ppc64le

This machine is not using pegas repositories, we are pointing straight at brew builds. It appears that the pegas repository is still exporting 7.4 or older versions of the packages.

We can provide access if that could help having it resolved.

Thanks
Fabio

Comment 2 Florian Weimer 2017-11-12 09:19:18 UTC
This is an upstream clang bug.  Apparently, this was fixed here:

llvm.org/viewvc/llvm-project/cfe/trunk/lib/Basic/Targets.cpp?rev=204627&r1=204626&r2=204627&view=diff

Note that clang in EPEL is very old.  You could try llvm-toolset to get a newer version:

https://developers.redhat.com/blog/2017/11/01/getting-started-llvm-toolset/

Comment 3 Fabio Massimo Di Nitto 2017-11-12 09:58:01 UTC
(In reply to Florian Weimer from comment #2)
> This is an upstream clang bug.  Apparently, this was fixed here:
> 
> llvm.org/viewvc/llvm-project/cfe/trunk/lib/Basic/Targets.
> cpp?rev=204627&r1=204626&r2=204627&view=diff
> 
> Note that clang in EPEL is very old.  You could try llvm-toolset to get a
> newer version:
> 
> https://developers.redhat.com/blog/2017/11/01/getting-started-llvm-toolset/

Hi Florian,

thanks for being super responsive as usual, and thanks for the pointers. We will wait for newer packages to land in EPEL. To the best extent we prefer not to add extra "non-official" repositories.

Cheers and have a nice weekend.
Fabio


Note You need to log in before you can comment on or make changes to this bug.